#include "game.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAX_RAND_TRIES_PER_WORD 10
#define EMPTY_CHAR 0

int createWordSalad(

    char salad[MAX_SEARCH_FIELD_LEN]
              [MAX_SEARCH_FIELD_LEN], // salad ist Spielfeld 2D Array mit 20*20
                                      // Buchstaben
    unsigned int searchFieldLen, const char words[][MAX_WORD_LEN],
    unsigned int wordCount) {

  enum Richtung { HORIZONTAL, VERTIKAL };

  for (int x = 0; x < searchFieldLen; x++) {

    for (int y = 0; y < searchFieldLen; y++) {

      salad[y][x] = EMPTY_CHAR; // Spielfeld auf EmptyChar setzen
    }
  }
  unsigned int placedWords = 0; // variable platzierte Wörter

  // Wörter platzieren
  // for schleife mit wortNummer = 0 bis wordCount - 1 (insgesamt wordCount)

  for (int wortNummer = 0; wortNummer < wordCount; wortNummer++) {

    // strlen mit Wortlänge
    int wortLen = strlen(words[wortNummer]);

    int platziert = 0; // variable, um platziertes Wort zu signalisieren
    int versuch = 0;   // veruche bis max rand tries

    while (versuch < MAX_RAND_TRIES_PER_WORD &&
           platziert == 0) { // wort platziert -> Schleife wird verlassen oder
                             // konnte nach 10 Versuchen nicht platziert werden

      enum Richtung r =
          (rand() % 2) ? HORIZONTAL : VERTIKAL; // mit rand Richtung

      int x = rand() % searchFieldLen; // mit rand Koordinaten bestimmen
      int y = rand() % searchFieldLen;
      int wortFrei = 1; // Wort passt ins Feld und überschneidet sich nicht

      if (r == VERTIKAL) {

        if ((y + wortLen) > (searchFieldLen)) { // Wortlänge größer als Feld
          wortFrei = 0;
        }

        for (int i = 0; (i < wortLen) && (wortFrei != 0); i++) {
          char var = salad[y + i][x];
          if (var != EMPTY_CHAR) {
            wortFrei = 0; // Wort überschneidet sich mit bereits platziertem
                          // Wort
          }
        }

        if (wortFrei != 0) {

          for (int i = 0; i < wortLen; i++) {

            salad[y + i][x] = words[wortNummer][i]; // Wort platzieren
          }
          placedWords++;
          platziert = 1; // schleife wird verlassen
        }

      }

      else if (r == HORIZONTAL) {

        if ((x + wortLen) > searchFieldLen) {
          wortFrei = 0;
        }

        for (int i = 0; (i < wortLen) && (wortFrei != 0); i++) {
          char var = salad[y][x + i];
          if (var != EMPTY_CHAR) {
            wortFrei = 0;
          }
        }

        if (wortFrei != 0) {

          for (int i = 0; i < wortLen; i++) {

            salad[y][x + i] = words[wortNummer][i];
          }
          placedWords++;
          platziert = 1;
        }
      }

      versuch++;
    }
  }

  for (int i = 0; i < searchFieldLen; i++) {

    for (int j = 0; j < searchFieldLen; j++) {

      if (salad[i][j] == EMPTY_CHAR) {

        salad[i][j] = rand() % (90 - 65 + 1) + 65;
      }
    }
  }
  return placedWords;
}

void showWordSalad(const char salad[MAX_SEARCH_FIELD_LEN][MAX_SEARCH_FIELD_LEN],
                   unsigned int searchFieldLen) {

  for (int i = 0; i < searchFieldLen; i++) {
    for (int j = 0; j < searchFieldLen; j++) {
      printf("%c", salad[i][j]);
    }
  }
}
